Commit 0ac83a20 authored by Marek Olšák's avatar Marek Olšák

mesa: disallow creation of GL 3.1 compatibility contexts

Death to driver-specific hacks!
Reviewed-by: default avatarIan Romanick <ian.d.romanick@intel.com>
parent 25409c6d
......@@ -89,11 +89,7 @@ intelInitExtensions(struct gl_context *ctx)
ctx->Extensions.ARB_texture_rgb10_a2ui = true;
if (intel->gen >= 6)
if (ctx->API == API_OPENGL_CORE) {
ctx->Const.GLSLVersion = 140;
} else {
ctx->Const.GLSLVersion = 130;
}
ctx->Const.GLSLVersion = 140;
else
ctx->Const.GLSLVersion = 120;
_mesa_override_glsl_version(ctx);
......
......@@ -345,6 +345,12 @@ _mesa_compute_version(struct gl_context *ctx)
switch (ctx->API) {
case API_OPENGL_COMPAT:
/* Disable GLSL 1.40 and later for legacy contexts.
* This disallows creation of the GL 3.1 compatibility context. */
if (ctx->Const.GLSLVersion > 130) {
ctx->Const.GLSLVersion = 130;
}
/* fall through */
case API_OPENGL_CORE:
compute_version(ctx);
break;
......
......@@ -570,10 +570,7 @@ void st_init_extensions(struct st_context *st)
glsl_feature_level = screen->get_param(screen, PIPE_CAP_GLSL_FEATURE_LEVEL);
if (glsl_feature_level >= 140) {
if (ctx->API == API_OPENGL_CORE)
ctx->Const.GLSLVersion = 140;
else
ctx->Const.GLSLVersion = 130;
ctx->Const.GLSLVersion = 140;
} else if (glsl_feature_level >= 130) {
ctx->Const.GLSLVersion = 130;
} else {
......
Markdown is supported
0% or .
You are about to add 0 people to the discussion. Proceed with caution.
Finish editing this message first!
Please register or to comment